var xDown = null;                                                        
var yDown = null;                                                        

function handleTouchStart(evt) {                                         
    xDown = evt.touches[0].clientX;                                      
    yDown = evt.touches[0].clientY;                                      
};                                                

function handleTouchMove(evt) {
    if ( ! xDown || ! yDown ) {
        return;
    }

    var xUp = evt.touches[0].clientX;                                    
    var yUp = evt.touches[0].clientY;

    var xDiff = xDown - xUp;
    var yDiff = yDown - yUp;
	//console.log(this);
    if ( Math.abs( xDiff ) > Math.abs( yDiff ) ) {/*most significant*/
        if ( xDiff > 0 ) {
			if(this.id == 'gaugeview' || this.id == 'editview'){
				prevDevice();
			}
			else{
				$( this ).find('.delete').animate({
					marginLeft: "0px"
				}, 300, function() {
					// Animation complete.
				});
			}			
            //console.log('left swipe');
        } else {
			if(this.id == 'gaugeview' || this.id == 'editview'){		
				nextDevice();
			}
			else{
				$( this ).find('.delete').animate({
					marginLeft: "55px"
				}, 300, function() {

				});
			}
        }
        //console.log('right swipe');                    
    } else {
        if ( yDiff > 0 ) {
            //console.log('top swipe');
        } else { 
            //console.log('down swipe');
        }                                                                 
    }
    /* reset values */
    xDown = null;
    yDown = null;                                             
};


function adjustBigImages(show){
	//console.log('adjustBigImage');
	//console.log('#calendarview .deviceimage height:'+$('#calendarview .deviceimage').height());
	//console.log('#calendarview .deviceimage width:'+$('#calendarview .deviceimage').width());
	if(show){
		var visibility = 'visible';
	}
	else{
		var visibility = 'hidden';
	}
	if($('#calendarview .deviceimage').height()){
		if($('#calendarview .deviceimage').height() >  $('#calendarview .deviceimage').width()){						
			var marginTop = ( $('#calendarview .deviceimage').height() - 110 ) / 2 ;
			$('#calendarview .deviceimage').css({height:'auto',width:'110px', marginTop:'-'+marginTop+'px', marginLeft:'0', visibility:visibility});
			$('#calendarview #deviceimagenochange2').css({height:'112px',width:'112px', marginLeft:'-111px', marginTop:'0', visibility:visibility});					
		}
		else{
			var marginLeft = ( $('#calendarview .deviceimage').width() - 110 ) / 2 ;
			var marginLeftRound = Math.round(marginLeft);
			if(marginLeftRound > marginLeft){
				marginLeftRound = marginLeftRound - 1;
			}
			$('#calendarview .deviceimage').css({height:'112px',width:'auto', marginLeft:'-'+marginLeft+'px', marginTop:'0', visibility:visibility});
			$('#calendarview #deviceimagenochange2').css({height:'112px',width:'112px', marginLeft:'-'+(111+marginLeftRound)+'px', marginTop:'0', visibility:visibility});
		}
	}

	if($('#editview .deviceimage').height()){
		if($('#editview .deviceimage').height() >  $('#editview .deviceimage').width()){
			var marginTop = ( $('#editview .deviceimage').height() - 110 ) / 2 ;
			$('#editview .deviceimage').css({height:'auto',width:'110px', marginTop:'-'+marginTop+'px', marginLeft:'0', visibility:visibility});
			$('#editview #deviceimagechange').css({height:'112px',width:'112px', marginLeft:'-110px', marginTop:'0', visibility:visibility});
		}
		else{
			var marginLeft = ( $('#editview .deviceimage').width() - 110 ) / 2 ;
			var marginLeftRound = Math.round(marginLeft);
			if(marginLeftRound > marginLeft){
				marginLeftRound = marginLeftRound - 1;
			}
			$('#editview .deviceimage').css({height:'112px',width:'auto', marginLeft:'-'+marginLeft+'px', marginTop:'0', visibility:visibility});
			$('#editview #deviceimagechange').css({height:'112px',width:'112px', marginLeft:'-'+(110+marginLeftRound)+'px', marginTop:'0', visibility:visibility});
		}
	}
}

function prevDevice(){
	$('.deviceimage, #deviceimagechange, #deviceimagenochange2').css({visibility:'hidden'});
	adjustBigImages(false);
	setTimeout(function(){adjustBigImages(true)}, 200);
	//console.log('event left');
	var prev = false;
	for(var key in app.devices){
		if(key == ui.activeDevice && prev){
			ui.activeDevice = prev;
			if(ui.activeView == 'calendarview'){
				oChart.init();
			}
			ui.updateDevicesView(false);
			$('#device-name').val(app.devices[ui.activeDevice].name);
			$('.marker').removeClass('active');
			if( app.devices[ui.activeDevice].voltType == 0 ){
				$('#vt0').addClass('active');
			}
			if( app.devices[ui.activeDevice].voltType == 1 ){
				$('#vt1').addClass('active');
			}
			if( app.devices[ui.activeDevice].voltType == 2 ){
				$('#vt2').addClass('active');
			}

			$('.deviceimage').attr('src', app.devices[ui.activeDevice].imageURI);
			$('#device-name').val(app.devices[ui.activeDevice].name);
			return;
		}
		prev = key;				
	}
	ui.activeDevice = prev;
	if(ui.activeView == 'calendarview'){
		oChart.init();
	}
	ui.updateDevicesView(false);
	$('#device-name').val(app.devices[ui.activeDevice].name);
	$('.marker').removeClass('active');
	if( app.devices[ui.activeDevice].voltType == 0 ){
		$('#vt0').addClass('active');
	}
	if( app.devices[ui.activeDevice].voltType == 1 ){
		$('#vt1').addClass('active');
	}
	if( app.devices[ui.activeDevice].voltType == 2 ){
		$('#vt2').addClass('active');
	}

	$('.deviceimage').attr('src', app.devices[ui.activeDevice].imageURI);
	$('#device-name').val(app.devices[ui.activeDevice].name);
	return;			
}

function nextDevice(){
	$('.deviceimage, #deviceimagechange, #deviceimagenochange2').css({visibility:'hidden'});
	adjustBigImages(false);
	setTimeout(function(){adjustBigImages(true)}, 200);
	//console.log('event right');
	var next = false;
	for(var key in app.devices){
		if(next){
			ui.activeDevice = key;
			if(ui.activeView == 'calendarview'){
				oChart.init();
			}
			ui.updateDevicesView(false);
			$('#device-name').val(app.devices[ui.activeDevice].name);
			$('.marker').removeClass('active');
			if( app.devices[ui.activeDevice].voltType == 0 ){
				$('#vt0').addClass('active');
			}
			if( app.devices[ui.activeDevice].voltType == 1 ){
				$('#vt1').addClass('active');
			}
			if( app.devices[ui.activeDevice].voltType == 2 ){
				$('#vt2').addClass('active');
			}

			$('.deviceimage').attr('src', app.devices[ui.activeDevice].imageURI);
			$('#device-name').val(app.devices[ui.activeDevice].name);
			return;
		}
		if(ui.activeDevice == key){
			next = true;
		}
	}

	for(var key in app.devices){
		ui.activeDevice = key;
		if(ui.activeView == 'calendarview'){
			oChart.init();
		}
		ui.updateDevicesView(false);
		$('#device-name').val(app.devices[ui.activeDevice].name);
		$('.marker').removeClass('active');
		if( app.devices[ui.activeDevice].voltType == 0 ){
			$('#vt0').addClass('active');
		}
		if( app.devices[ui.activeDevice].voltType == 1 ){
			$('#vt1').addClass('active');
		}
		if( app.devices[ui.activeDevice].voltType == 2 ){
			$('#vt2').addClass('active');
		}

		$('.deviceimage').attr('src', app.devices[ui.activeDevice].imageURI);
		$('#device-name').val(app.devices[ui.activeDevice].name);
		return;
	}			
}
		

function matchListImage(image){		
	console.log( ('w:'+$(image).width() +'|h:'+$(image).height()) );
	if($(image).height() > $(image).width()){				
		console.log('portait|mt:'+'-'+( ( $(image).height()/2 ) - 27));
		$(image).css({height:'auto',width:'55px'});
		$(image).css({marginTop:'-'+( ( $(image).height()/2 ) - 27)+'px',marginLeft:'5px'});
		$(image).next().css({marginLeft:'-60px'});
	}
	else{
		console.log(('landscape|ml:'+'-'+( ( $(image).width()/2 ) - 27)));
		$(image).css({height:'55px',width:'auto'});
		$(image).css({marginLeft:'-'+( ( $(image).width()/2 ) - 32)+'px'});
		$(image).next().css({marginLeft:'-'+( ($(image).width()/2-22)+54)+'px'});
	}
}

function dhm(ms){
    days = Math.floor(ms / (24*60*60*1000));
    if(days < 10)days = '0'+days;
    daysms=ms % (24*60*60*1000);
    hours = Math.floor((daysms)/(60*60*1000));
    if(hours < 10)hours = '0'+hours;
    hoursms=ms % (60*60*1000);
    minutes = Math.floor((hoursms)/(60*1000));
    if(minutes < 10)minutes = '0'+minutes;
    minutesms=ms % (60*1000);
    sec = Math.floor((minutesms)/(1000));
    if(sec < 10)sec = '0'+sec;
    if(parseInt(days) > 0)
		return days+":"+hours+":"+minutes+":"+sec;
	if(parseInt(hours) > 0)
		return hours+":"+minutes+":"+sec;
	if(parseInt(minutes) > 0)
		return minutes+":"+sec;
	if(parseInt(sec) > 0)
		return sec;
}

function detailsClicked(){
	//console.log('updateDevicesView');
	ui.activeView = 'gaugeview';
	ui.updateDevicesView(false);
	ui.activeDevice = $(this).attr('rel').replace(/:/g, "_");
	$('#gaugeview').show();
	$('#deleteview').hide();
	$('#back').show();
	$('#edit').show();
	$('#calendar').show();
	$('#gauge-button').show();
	$('#scan').hide();
	$('#devices-frame').hide();
	$('#device-name').val(app.devices[ui.activeDevice].name);
	$('.marker').removeClass('active');
	if( app.devices[ui.activeDevice].voltType == 0 ){
		$('#vt0').addClass('active');
	}
	if( app.devices[ui.activeDevice].voltType == 1 ){
		$('#vt1').addClass('active');
	}
	if( app.devices[ui.activeDevice].voltType == 2 ){
		$('#vt2').addClass('active');
	}

	var portrait = '';
	if($(window).width() > $(window).height()){
		portrait = ' portrait';
	}
	if(app.language == 'de'){
		$('body')[0].className = 'german gauge'+portrait;
	}
	else{
		$('body')[0].className = 'english gauge'+portrait;
	}
}
				
var ui = {
	stopLoop:false,
	activeDevice:0,
	activeView:'devices',
	gaugeTitle:{'de':{
					'fullydischarged':'tiefentladen',
					'discharged':'entladen',
					'partiallycharged':'teil geladen',
					'charged':'geladen'},
				'en':{
					'fullydischarged':'fully discharged',
					'discharged':'discharged',
					'partiallycharged':'partially charged',
					'charged':'charged'}
	},	
	minValues: [5.95,12.00,24.00],
	maxValues: [6.30,12.55,25.05],
	highlights:[[
					 { from : 5.95,   to : 6.01, color : '#9d0d15'},
					 { from : 6.01,   to : 6.05, color : '#e95d0f'},
					 { from : 6.05,   to : 6.25, color : '#bdbf0d'},
					 { from : 6.25,   to : 6.30, color : '#41a62a'}
				],[
					{ from : 12.00,   to : 12.03, color : '#9d0d15'},
					{ from : 12.03,   to : 12.09, color : '#e95d0f'},
					{ from : 12.09,   to : 12.51, color : '#bdbf0d'},
					{ from : 12.51,   to : 12.55, color : '#41a62a'}
				],[
					{ from : 24.00,   to : 24.04, color : '#9d0d15'},
					{ from : 24.04,   to : 24.19, color : '#e95d0f'},
					{ from : 24.19,   to : 25.00, color : '#bdbf0d'},
					{ from : 25.00,   to : 25.05, color : '#41a62a'}
				]
	],
	statusTexts:{
		'de':{
			'disconnected':'getrennt',
			'out_of_reach':'außer Reichweite',
			'closed':'getrennt',
			'found':'in Reichweite',
			'connected':'verbunden',
			'discovered':'verbunden',
			'subscribed':'verbunden',
			'error':'Fehler',
			'subscribedResult':'empfange'
		},
		'en':{
			'disconnected':'disconnected',
			'out_of_reach':'out of reach',
			'closed':'disconnected',
			'found':'inreach',
			'connected':'connected',
			'discovered':'connected',
			'subscribed':'connected',
			'error':'error',
			'subscribedResult':'receiving'
		},
	},
	legendTexts:{
		'de':[
			[
				'Bis 6.01 V',
				'6.01 V bis 6.05 V',
				'6.05 V bis 6.25 V',
				'bis 6.30 V'
			],[
				'Bis 12.03 V',
				'12.03 V bis 12.09 V',
				'12.09 V bis 12.51 V',
				'bis 12.55 V'
			],[
				'Bis 24.04 V',
				'24.04 V bis 24.19 V',
				'24.19 V bis 25.00 V',
				'bis 25.05 V'
			]
		],			
		'en':[
			[
				'Until 6.01 V',
				'6.01 V until 6.05 V',
				'6.05 V until 6.25 V',
				'from 6.30 V'
			],[
				'Until 12.03 V',
				'12.03 V until 12.09 V',
				'12.09 V until 12.51 V',
				'from 12.55 V'
			],[
				'Until 24.04 V',
				'24.04 V until 24.19 V',
				'24.19 V until 25.00 V',
				'from 25.05 V'
			]
		]
	},
	statusClass:{
		'out_of_reach':'disconnected',
		'closed':'disconnected',
		'found':'inreach',
		'connected':'connected',
		'discovered':'connected',
		'subscribed':'connected',
		'error':'error',
		'subscribedResult':'receiving'
	},
	voltTexts:[
		'6','12','24'
	],
    initialize: function() {		
		//console.log('ui.initialize');
        this.bindEvents();
    },
    bindEvents: function() {
		//console.log('ui.bindEvents');
		$('#text').html('<p>Ready</p>');
		$('#scan').click(app.startScan);
		$('#logo').click(function(){

			if($('#debug').is(':visible')){
				$('#debug').hide();
			}
			else{
				$('#debug').show();
			}
		});
		$('#back').on('click', function(){
			//console.log('event back');
			ui.activeView = 'devices';
			$('#gaugeview').hide();
			$('#back').hide();
			$('#scan').show();
			$('#devices-frame').show();
			$('#editview').hide();
			$('#calendarview').hide();
			ui.updateDevicesView(false);
			var devices = app.getDevices();
			for(var key in devices){
				matchListImage(app.devices[key].htmlElements.deviceImageElement);
			}
			var portrait = '';
			if($(window).width() > $(window).height()){
				portrait = ' portrait';
			}
			if(app.language == 'de'){
				$('body')[0].className = 'german devices'+portrait;
			}
			else{
				$('body')[0].className = 'english devices'+portrait;
			}
			ui.updateDevicesView(false);
		});
		$('.edit-inactive').on('click', function(){
			$('.deviceimage, #deviceimagechange, #deviceimagenochange2').css({visibility:'hidden'});
			//console.log('event edit');
			ui.activeView = 'editview';
			$('#gaugeview').hide();
			$('#back').show();
			$('#scan').hide();
			$('#devices-frame').hide();
			$('#editview').show();
			$('#calendarview').hide();
			ui.updateDevicesView(false);
			var portrait = '';
			if($(window).width() > $(window).height()){
				portrait = ' portrait';
			}
			if(app.language == 'de'){
				$('body')[0].className = 'german edit'+portrait;
			}
			else{
				$('body')[0].className = 'english edit'+portrait;
			}
			$('#editview .deviceimage').attr('src', app.devices[ui.activeDevice].imageURI);
			$('.deviceimage, #deviceimagechange, #deviceimagenochange2').css({visibility:'hidden'});
			adjustBigImages(false);
			setTimeout(function(){adjustBigImages(true)}, 200);	
		});
		$('.gauge-inactive').on('click', function(){
			//console.log('event gauge');
			ui.activeView = 'gaugeview';
			$('#gaugeview').show();
			$('#back').show();
			$('#scan').hide();
			$('#devices-frame').hide();
			$('#editview').hide();
			$('#calendarview').hide();
			ui.updateDevicesView(false);
			var portrait = '';
			if($(window).width() > $(window).height()){
				portrait = ' portrait';
			}
			if(app.language == 'de'){
				$('body')[0].className = 'german gauge'+portrait;
			}
			else{
				$('body')[0].className = 'english gauge'+portrait;
			}
			ui.updateDevicesView(false);
		});
		$('.calendar-inactive').on('click', function(){
			$('.deviceimage, #deviceimagechange, #deviceimagenochange2').css({visibility:'hidden'});
			//console.log('event calendar');
			ui.activeView = 'calendarview';
			$('#calendarview').show();
			$('#gaugeview').hide();
			$('#back').show();
			$('#scan').hide();
			$('#devices-frame').hide();
			$('#editview').hide();
			ui.updateDevicesView(false);
			oChart.init();
			var portrait = '';
			if($(window).width() > $(window).height()){
				portrait = ' portrait';
			}
			if(app.language == 'de'){
				$('body')[0].className = 'german calendar'+portrait;
			}
			else{
				$('body')[0].className = 'english calendar'+portrait;
			}
			ui.updateDevicesView(false);
			$('#calendarview .deviceimage').attr('src', app.devices[ui.activeDevice].imageURI);	
			$('.deviceimage, #deviceimagechange, #deviceimagenochange2').css({visibility:'hidden'});
			adjustBigImages(false);
			setTimeout(function(){adjustBigImages(true)}, 200);
		});
		$('.btactivate').on('click', function(){
			app.enable();
		});		
		$('#save').on('click', function(){
			//console.log('event save');
			app.devices[ui.activeDevice].name = $('#device-name').val();
			if($('.select-volt .active').length == 0){
				app.devices[ui.activeDevice].voltType = '?';
			}
			else{
				app.devices[ui.activeDevice].voltType = $('.select-volt .active').attr('rel');
			}
			app.deviceValuesChanged = true;
			$('#save').addClass('saved');
			setTimeout(function(){$('#save').removeClass('saved');}, 1000);
			$('#'+app.devices[ui.activeDevice].address.replace(/:/g, "_")+' .device-name').html(app.devices[ui.activeDevice].name);
			ui.updateDevicesView(false);
		});
		
		$('.device-right').on('click', nextDevice);
		document.getElementById('editview').addEventListener('touchstart', handleTouchStart, false);
		document.getElementById('gaugeview').addEventListener('touchstart', handleTouchStart, false);
		document.getElementById('editview').addEventListener('touchmove', handleTouchMove, false);
		document.getElementById('gaugeview').addEventListener('touchmove', handleTouchMove, false);
		

		$('.device-left').on('click', prevDevice);
		
		$('.marker').on('click', function(){
			$('.marker').removeClass('active');
			$(this).addClass('active');
		});
		$('#deviceimagechange').on('click', 
			function(){
				navigator.camera.getPicture(
					function(imageURI){
						window.resolveLocalFileSystemURL(imageURI,
							function(entry){
								console.log(entry.name);
								var d = new Date();
								var n = d.getTime();
								var newFileName = n + '.jpg';
								var targetFolder = 'images';
								window.requestFileSystem(
									LocalFileSystem.PERSISTENT,
									0,
									function(fileSys){
										console.log('got Filesystem');
										console.log(fileSys.root);
										console.log(fileSys.root.getDirectory);
										fileSys.root.getDirectory(
											targetFolder,
											{create:true},
											function(directory){
												console.log('move');
												entry.moveTo(
													directory, 
													newFileName, 
													function(new_entry){
														console.log('move success');
														var newImageUri = new_entry.toURL();
														app.devices[ui.activeDevice].imageURI = newImageUri;
														$('.deviceimage').attr('src', app.devices[ui.activeDevice].imageURI);		
														var copyDevices = {};
														for(var key in app.devices){
															copyDevices[key] = 	{address:app.devices[key].address,name:app.devices[key].name,scans:app.devices[key].scans,status:app.devices[key].status,time:app.devices[key].time,working:app.devices[key].working,voltType:app.devices[key].voltType,volt:app.devices[key].volt,imageURI:app.devices[key].imageURI,htmlElements:{}};
														}
														localStorage.setItem("devices12", JSON.stringify(copyDevices));
														var deviceImageElement = $('#'+app.devices[ui.activeDevice].address.replace(/:/g, "_")+' .deviceimagelist');

														$(this).css({height:'auto',width:'auto'});
														deviceImageElement.attr('src', app.devices[ui.activeDevice].imageURI);
														adjustBigImages(false);
														setTimeout(function(){adjustBigImages(true)}, 200);
													},
													function(error){
														console.log(error);
													}
												);
											},
											function(error){
												console.log(error);
											}
										);
									},
									function(error){
										console.log(error);
									}
								);
							},
							function(){
								alert('error on moving photo')
							}
						);
					},
					function(){
					
					},
					{
						destinationType:navigator.camera.FILE_URI,
						encodingType:navigator.camera.JPEG,
						mediaType:navigator.camera.PICTURE,
						sourceType: Camera.PictureSourceType.PHOTOLIBRARY,
						targetHeight:200,
						targetWidth:200,
						correctOrientation:true
					});
			}
		);			

		$('#device-name').on('focus', function(){
			$('.nav').hide();
		});
		$('#device-name').on('blur', function(){
			$('.nav').show();
		});
		$('.deviceimage').on('load', function(){adjustBigImages(true);});
		$('#homepage').on('click', function(){window.open("http://www.battery-guard.net","_system");});
		$('#helpdesk').on('click', function(){window.open("http://helpdesk.battery-guard.net","_system");});
		ui.updateDevicesView(true);		
        ui.setGaugeArray();
        ui.gauge.draw();
    },
    addDevice:function(key, deviceData){
		if($('.device').length == 0){
			$('#devices').html('');
		}
		//console.log('ui.addDevice');
		if(typeof(app.devices[key].htmlElements)=='undefined'){
			app.devices[key].htmlElements = {};
		}
		app.devices[key].htmlElements.deviceElement = $('<div class="device" rel="'+key+'" id="'+key+'">');
		app.devices[key].htmlElements.deviceImageElement = $('<img class="deviceimagelist" src="'+deviceData.imageURI+'" />');
		app.devices[key].htmlElements.deviceImageFrameElement = $('<div class="deviceimageframe" rel="'+key+'"></div>');
		app.devices[key].htmlElements.holeImage = $('<img src="img/hole-s.png" class="list-hole">');
		
		app.devices[key].htmlElements.deviceImageElement.on('load', function(){
			matchListImage(this);
		});
		
		app.devices[key].htmlElements.deviceImageFrameElement.append(app.devices[key].htmlElements.deviceImageElement);		
		app.devices[key].htmlElements.deviceImageFrameElement.append(app.devices[key].htmlElements.holeImage);
		app.devices[key].htmlElements.deviceElement.append(app.devices[key].htmlElements.deviceImageFrameElement);
		
		var status = ui.statusClass[deviceData.status.replace(/ /g, "_")];
		var statusText = ui.statusTexts[app.language]['out_of_reach'];			
		if(typeof(ui.statusTexts[app.language][deviceData.status.replace(/ /g, "_")]) != 'undefined'){
			statusText = ui.statusTexts[app.language][deviceData.status.replace(/ /g, "_")];
		}
		if(ui.voltTexts[deviceData.voltType] == '?'){
			voltText = '?';
		}
		else{
			voltText = ui.voltTexts[deviceData.voltType];
		}
		var chargingState = ui.getChargingState(deviceData);
		var lastSignalTime = parseInt(( Date.now() - deviceData.time ) );

		if( lastSignalTime > 604800000 ){
			var heartBeatTextDe = 'über eine Woche';
			var heartBeatTextEn = 'more than a week';
		}
		else{
			heartBeatText = dhm(lastSignalTime);
			if(typeof(heartBeatText) == 'undefined')heartBeatText = '00';
		}

		if(typeof(voltText) == 'undefined')voltText = '?';

		app.devices[key].htmlElements.deviceInfoElement = $('<div class="device-info" rel="'+key+'"></div>');
		app.devices[key].htmlElements.deviceName = $('<div class="device-name">'+deviceData.name+'</div>');
		app.devices[key].htmlElements.deviceInfoElement.append(app.devices[key].htmlElements.deviceName);
		app.devices[key].htmlElements.deviceHeartbeat = $('<div class="device-heartbeat"></div>');
		app.devices[key].htmlElements.deviceInfoElement.append(app.devices[key].htmlElements.deviceHeartbeat);
		app.devices[key].htmlElements.deviceInfoElement.append($('<div class="clear"></div>'));
		app.devices[key].htmlElements.deviceVolt = $('<div class="device-volt '+chargingState.state+'">'+voltText+' V</div>');
		app.devices[key].htmlElements.deviceInfoElement.append(app.devices[key].htmlElements.deviceVolt);
		app.devices[key].htmlElements.deviceStatus = $('<div class="device-status"><span class="german '+status+'">'+statusText+'</span><span class="english '+status+'">'+statusText+'</span></div>');
		app.devices[key].htmlElements.deviceInfoElement.append(app.devices[key].htmlElements.deviceStatus);
		app.devices[key].htmlElements.deviceElement.append(app.devices[key].htmlElements.deviceInfoElement);
		var color = chargingState.state;			
		if( ( Date.now() - deviceData.time )  > 17280000){
			color = 'grey';
		}
		app.devices[key].htmlElements.deviceDetailsButtonElement = $('<div class="device-details-button '+color+'" rel="'+key+'"></div>');
		
		app.devices[key].htmlElements.deviceElement.on('click', detailsClicked);		
		
		app.devices[key].htmlElements.deviceDeleteElement = $('<div class="delete" rel="'+key+'"></div>');
		app.devices[key].htmlElements.deviceDeleteElement.on('click', function(event){
				event.stopPropagation();
				app.deleteDevice($(this).attr('rel').replace(/_/g, ":"));
				$(this).parent().parent().remove();
			}
		);
		app.devices[key].htmlElements.deviceDetailsButtonElement.append(app.devices[key].htmlElements.deviceDeleteElement);
		
		app.devices[key].htmlElements.deviceElement[0].addEventListener('touchstart', handleTouchStart, false);
		app.devices[key].htmlElements.deviceElement[0].addEventListener('touchmove', handleTouchMove, false);
		app.devices[key].htmlElements.deviceElement.append(app.devices[key].htmlElements.deviceDetailsButtonElement);
		$('#devices').append(app.devices[key].htmlElements.deviceElement);
		app.devices[key].htmlElements.deviceInfoElement.width($('body').width()-125);
	},
    renderDevices:function(){
		//console.log('ui.renderDevices');
		var devices = app.getDevices();
		$('#devices').html('');
		if(objHasProps(devices) == 0){
			$('#devices').html('<h1 id="nosenders"><span class="english">No senders in reach</span><span class="german">Keine Sender in Reichweite</span></h1>');
		}
		else{
			for(var key in devices){
				ui.addDevice(key, devices[key]);
			}
		}
	},
	updateDevicesView:function(loop){		
		//console.log('ui.updateDevicesView');

		if(objHasProps(app.devices)){
			var copyDevices = {};
			for(var key in app.devices){
				copyDevices[key] = 	{address:app.devices[key].address,name:app.devices[key].name,scans:app.devices[key].scans,status:app.devices[key].status,time:app.devices[key].time,working:app.devices[key].working,voltType:app.devices[key].voltType,volt:app.devices[key].volt,imageURI:app.devices[key].imageURI,htmlElements:{}};
			}
			localStorage.setItem("devices12", JSON.stringify(copyDevices));
		}
		
		var devices = app.getDevices();
		if(ui.activeView == 'devices'){
			var count6v = 0;
			var count12v = 0;
			var count24v = 0;
			var countFullydischarged = 0
			var countDischarged = 0
			var countPartiallycharged = 0
			var countCharged = 0
			
			if(app.deviceValuesChanged == true){
				for(var key in devices){
					if(typeof(app.devices[key].htmlElements)=='undefined')continue;
					
					if(devices[key].voltType == 0){
						count6v++;
					}
					if(devices[key].voltType == 1){
						count12v++;
					}
					if(devices[key].voltType == 2){
						count24v++;
					}
					var deviceElement = app.devices[key].htmlElements.deviceElement

					var status = ui.statusClass[devices[key].status.replace(/ /g, "_")];
					var statusText = ui.statusTexts[app.language]['out_of_reach'];			
					if(typeof(ui.statusTexts[app.language][devices[key].status.replace(/ /g, "_")]) != 'undefined'){
						statusText = ui.statusTexts[app.language][devices[key].status.replace(/ /g, "_")];
					}
					if(ui.voltTexts[devices[key].voltType] == '?'){
						voltText = '?';
					}
					else{
						voltText = ui.voltTexts[devices[key].voltType];
					}
					var chargingState = ui.getChargingState(devices[key]);
					if(chargingState.state == 'fullydischarged'){
						countFullydischarged++;
					}
					if(chargingState.state == 'discharged'){
						countDischarged++;
					}
					if(chargingState.state == 'partiallycharged'){
						countPartiallycharged++;
					}
					if(chargingState.state == 'charged'){
						countCharged++;
					}
					var lastSignalTime = parseInt(( Date.now() - devices[key].time ) );

					if( lastSignalTime > 604800000 ){
						if(app.language == 'de')
							var heartBeatText = 'über eine Woche';
						else
							var heartBeatText = 'more than a week';
					}
					else{
						var heartBeatText = dhm(lastSignalTime);
						if(typeof(heartBeatText) == 'undefined')heartBeatText = '00';
					}
					var color = chargingState.state;			
					if( ( Date.now() - devices[key].time )  > 17280000){
						color = 'grey';
					}
					if(typeof(voltText) == 'undefined')voltText = '?';			
					app.devices[key].htmlElements.deviceVolt[0].childNodes[0].nodeValue = voltText+' V'
					app.devices[key].htmlElements.deviceStatus[0].innerHTML = '<span class="german '+status+'">'+statusText+'</span><span class="english '+status+'">'+statusText+'</span>';
					app.devices[key].htmlElements.deviceDetailsButtonElement[0].className = 'device-details-button '+color;
				}
				$('#filter-extended-6v .count').html('('+count6v+')');
				$('#filter-extended-12v .count').html('('+count12v+')');
				$('#filter-extended-24v .count').html('('+count24v+')');
				$('#filter-extended-fullydischarged .count').html('('+countFullydischarged+')');
				$('#filter-extended-discharged .count').html('('+countDischarged+')');
				$('#filter-extended-partially-charged .count').html('('+countPartiallycharged+')');
				$('#filter-extended-charged .count').html('('+countCharged+')');
				app.deviceValuesChanged = false;
			}
			else{
				if(objHasProps(devices) == 0){
					$('#devices').html('<h1 id="nosenders"><span class="english">No senders in reach</span><span class="german">Keine Sender in Reichweite</span></h1>');
				}
			}
		}		
		
		if(ui.activeDevice != 0){			
			var chargingStateActive = ui.getChargingState(devices[ui.activeDevice]);
			$('.device-nav-name').html(devices[ui.activeDevice].name).attr('class', 'device-nav-name '+chargingStateActive.state);

			if( devices[ui.activeDevice].voltType == '?'){
				voltText = '?';
			}
			else{
				voltText = ui.voltTexts[devices[ui.activeDevice].voltType];
			}
			$('.devices-volt').html(voltText+'V');
			
			// GAUGE
			if(ui.activeView == 'gaugeview'){
				$('#chargingstate').html(ui.gaugeTitle[app.language][chargingStateActive.state]);
				var statusText = ui.statusTexts[app.language]['out_of_reach'];			
				if(typeof(ui.statusTexts[app.language][devices[ui.activeDevice].status.replace(/ /g, "_")]) != 'undefined'){
					statusText = ui.statusTexts[app.language][devices[ui.activeDevice].status.replace(/ /g, "_")];
				}
				var status = ui.statusClass[devices[ui.activeDevice].status.replace(/ /g, "_")];
				$('#gaugeview').attr('class', chargingStateActive.state);
				$('#status').html(statusText);
				$('#status').attr('class', status);			
				if( devices[ui.activeDevice].volt == '?'){
					ui.gauge.setValue(0);
				}
				else{
					ui.gauge.setValue(devices[ui.activeDevice].volt);
				}
				
				var gaugeWidth;
				if( $(window).width() > $(window).height() ){
					gaugeWidth = ( $('#gaugeview .h50').height() * 1.2);
				}
				else{
					gaugeWidth = ( $(window).height() * 0.5 );
				}
				if( devices[ui.activeDevice].volt != '?' && devices[ui.activeDevice].voltType != '?'){
					ui.gauge.updateConfig({
						width       : gaugeWidth,
						height      : gaugeWidth,
						title       : ui.gaugeTitle[app.language][devices[ui.activeDevice].voltType], 
						minValue    : ui.minValues[devices[ui.activeDevice].voltType],
						maxValue    : ui.maxValues[devices[ui.activeDevice].voltType],
						highlights  : ui.highlights[devices[ui.activeDevice].voltType]
					});
				}
			}
			// CALENDAR
			if(ui.activeView == 'calendarview'){
				if(devices[ui.activeDevice].voltType == '?'){
					
				}
				else{
					$('#legend .fullydischarged').html(ui.legendTexts[app.language][devices[ui.activeDevice].voltType][0]);
					$('#legend .discharged').html(ui.legendTexts[app.language][devices[ui.activeDevice].voltType][1]);
					$('#legend .partiallycharged').html(ui.legendTexts[app.language][devices[ui.activeDevice].voltType][2]);
					$('#legend .charged').html(ui.legendTexts[app.language][devices[ui.activeDevice].voltType][3]);
				}
			}			
			// EDIT
			if(ui.activeView == 'editview'){

			}
		}

		if(loop){
			ui.updateDVTimer = setTimeout(function(){ui.updateDevicesView(true)}, 1500);
		}
	},
	showBTEnable:function(){
		//console.log('ui.showBTEnable');
		$('#calendarview').hide();
		$('#gaugeview').hide();
		$('#back').show();
		$('#scan').hide();
		$('#devices').hide();
		$('#editview').hide();
		$('#bt-activate').show();
	},
	showDevices:function(){
		//console.log('ui.showDevices');
		$('#calendarview').hide();
		$('#gaugeview').hide();
		$('#back').show();
		$('#scan').hide();
		$('#devices').show();
		$('#editview').hide();
		$('#bt-activate').hide();
	},
	getChargingState:function(device){
		//console.log('ui.getChargingState');
		if(device.voltType == 0){
			if( device.volt < 6.01){
				return { state:'fullydischarged', color:'#9d0d15' }
			}
			if( device.volt < 6.05){
				return { state:'discharged', color:'#e95d0f' }
			}
			if( device.volt < 6.25){
				return { state:'partiallycharged', color:'#bdbf0d' }
			}
			return { state:'charged', color:'#41a62a' }
			
		}
		if(device.voltType == 1){
			if( device.volt < 12.03){
				return { state:'fullydischarged', color:'#9d0d15' }
			}
			if( device.volt < 12.09){
				return { state:'discharged', color:'#e95d0f' }
			}
			if( device.volt < 12.51){
				return { state:'partiallycharged', color:'#bdbf0d' }
			}
			return { state:'charged', color:'#41a62a' }					
		}
		if(device.voltType == 2){
			if( device.volt < 24.04){
				return { state:'fullydischarged', color:'#9d0d15' }
			}
			if( device.volt < 24.19){
				return { state:'discharged', color:'#e95d0f' }
			}
			if( device.volt < 25.00){
				return { state:'partiallycharged', color:'#bdbf0d' }
			}
			return { state:'charged', color:'#41a62a' }			
		}
		return { state:'grey', color:'grey' };
	},	
    setGaugeArray: function (){
		//console.log('ui.setGaugeArray');
        //Gauge erzeugen
        var gaugeWidth;
        if( $(window).width() > $(window).height() ){
			gaugeWidth = ( $(window).height() / 1.6 );
		}
		else{
			gaugeWidth = ( $(window).height() * 0.5 );
		}
    	ui.gauge = new Gauge({
    		renderTo    : 'gauge',
    		width       : gaugeWidth,
            height      : gaugeWidth,
    		glow        : true,
    		units       : 'Volt',
    		title       : '?',
    		minValue    : 5.95,
    		maxValue    : 6.3,
    		majorTicks  : false,
    		minorTicks  : 2,
    		strokeTicks : false,
            animation : { delay    : 1,
    			          duration : 1,
    			          fn       : 'cycle' },
    		highlights  : ui.highlights[0] ,
    		colors      : {
    			plate      : '#222',
    			majorTicks : '#f5f5f5',
    			minorTicks : '#ddd',
    			title      : '#fff',
    			units      : '#fff',
    			numbers    : '#FFF',
    			needle     : { start : 'rgba(240, 128, 128, 1)', end : 'rgba(240, 128, 128, 1)' }
    		}
    	});
    	ui.gauge.setValue(0);
    }
};

window.onload = function(){
	ui.initialize();
	if($(window).width() > $(window).height()){
		$('body').addClass('portrait');
	}
	else{
		$('body').removeClass('portrait');		
	}
}

window.onresize = function(){
	
	if($(window).width() > $(window).height()){
		$('body').addClass('portrait');
	}
	else{
		$('body').removeClass('portrait');		
	}
	oChart.init();
	$('.device-info').width($('body').width()-115);
	ui.updateDevicesView(false);
	adjustBigImages(true);
}
